////////////////////////////////////////////////////////////////////////////////////////////////
//
//  O:Ǝ̃Jŕ`悵e\
//	쐬;kion
//	:|XgGtFNg
//	:
//		J̉ftXN[ŕ\		
//
////////////////////////////////////////////////////////////////////////////////////////////////
// GtFNg錾 //
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "object";
	string ScriptOrder = "standard";
> = 0.8;
////////////////////////////////////////////////////////////////////////////////////////////////
// ړ
// (ʒuA͈)
float2 ForwardDistance	= {7.0, 5.0};	// Y
float2 BackDistance		= {8.0, 5.0};	// Z
float2 LeftDistance		= {7.0, 5.0};	// X
float2 RightDistance	= {-7.0, 5.0};	// X
float2 DownDistance	= {1.0, 5.0};	// Y
float2 UpDistance	= {22.0, 5.0};	// Y

// ʒuw
float4x4 CenterControl	: CONTROLOBJECT < string name = "CenterControl.x"; >;
float4x4 CenterControlB	: CONTROLOBJECT < string name = "CenterControlB.x"; >;
float4x4 LeftControl	: CONTROLOBJECT < string name = "LeftControl.x"; >;
float4x4 RightControl	: CONTROLOBJECT < string name = "RightControl.x"; >;
float4x4 LeftArm	: CONTROLOBJECT < string name = "LeftArm.x"; >;
float4x4 RightArm	: CONTROLOBJECT < string name = "RightArm.x"; >;

// ړ
float3 Velocity = float3( 3, 3, 3 );
float3 RotateYPR = float3( radians(4.0), radians(4.0), radians(4.0) );

////////////////////////////////////////////////////////////////////////////////////////////////
// ړۑ
#define TEX_WIDTH	1
#define TEX_HEIGHT	2
texture texMoveMatDB : RenderDepthStencilTarget <
	int Width=TEX_WIDTH; int Height=TEX_HEIGHT; string Format = "D24S8";
>;
texture texMoveMat1 : RenderColorTarget <
	int Width=TEX_WIDTH; int Height=TEX_HEIGHT; string Format="A32B32G32R32F";
>;
shared texture texMoveMat2 : RenderColorTarget <
	int Width=TEX_WIDTH; int Height=TEX_HEIGHT; string Format="A32B32G32R32F";
>;
sampler smpMoveMat1 = sampler_state{
	Texture = <texMoveMat1>;
	MinFilter = POINT; MagFilter = POINT; MipFilter = POINT;
    AddressU = Wrap; AddressV = Wrap;
};
sampler smpMoveMat2 = sampler_state{
	Texture = <texMoveMat2>;
	MinFilter = POINT; MagFilter = POINT; MipFilter = POINT;
    AddressU = Wrap; AddressV = Wrap;
};

////////////////////////////////////////////////////////////////////////////////////////////////
// Op[^ //
// [s]
float time_0_X : Time;
// eNX`ItZbg
static float2 TexOffset = (float2)0.5/float2(TEX_WIDTH,TEX_HEIGHT);

// NH[^jIs
float4x4 Quaternion2Matrix(float4 q){
	return float4x4(
				1-2*q.y*q.y-2*q.z*q.z,	2*q.x*q.y-2*q.w*q.z,	2*q.x*q.z+2*q.w*q.y,	0,
				2*q.x*q.y+2*q.w*q.z,	1-2*q.x*q.x-2*q.z*q.z,	2*q.y*q.z-2*q.w*q.x,	0,
				2*q.x*q.z-2*q.w*q.y,	2*q.y*q.z+2*q.w*q.x,	1-2*q.x*q.x-2*q.y*q.y,	0,
				0,						0,						0,						1	);
}
// Yaw(Y)
float4 QuaternionYaw(float rad){
	return float4(0, sin(rad*0.5), 0, cos(rad*0.5));
}
// Pitch(X)
float4 QuaternionPitch(float rad){
	return float4(sin(rad*0.5), 0, 0, cos(rad*0.5));
}
// Roll(Z)
float4 QuaternionRoll(float rad){
	return float4(0, 0, sin(rad*0.5), cos(rad*0.5));
}
// Multiply
float4 QuaternionMultiply(float4 q1, float4 q2){
	return float4(	q1.w*q2.x+q2.w*q1.x + q1.y*q2.z - q1.z*q2.y,
					q1.w*q2.y+q2.w*q1.y + q1.z*q2.x - q1.x*q2.z,
					q1.w*q2.z+q2.w*q1.z + q1.x*q2.y - q1.y*q2.x,
					q1.w*q2.w-q1.x*q2.x-q1.y*q2.y-q1.z*q2.z		);
}
// Inverse
float4 QuaternionInverse(float4 q){
	q.w*=-1;
	return q / length(q);
}
// Normalize
float4 QuaternionNormalize(float4 q){
	return q/length(q);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// _o
struct VS_OUTPUT {
	float4 Pos	: POSITION;
	float2 Tex	: TEXCOORD0;
};
// ړ
// _VF[_
VS_OUTPUT MoveVS( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
	VS_OUTPUT Out = (VS_OUTPUT)0;
	Out.Pos = Pos;
	Out.Tex = Tex + TexOffset;
	return Out;
}
// sNZVF[_
float4 MovePS1( VS_OUTPUT In ) : COLOR
{
	float4 Color = (float4)1;
	if(time_0_X < 0.5){
		Color = float4(0,0,0,1);
	}
	else{
		Color=tex2D(smpMoveMat2, In.Tex);
	}
	return Color;
}
// sNZVF[_
float4 MovePS2( VS_OUTPUT In ) : COLOR
{
	float4 Color = (float4)1;
	Color=tex2D(smpMoveMat1, In.Tex);
	if(In.Tex.y<1.0/TEX_HEIGHT){
		// ɈړʂvZ
		float3 mv=(float3)0;
		// Oi
		mv.z -= 1.0 - saturate(abs(ForwardDistance.x-CenterControl._42)/ForwardDistance.y);
		mv.z -= 1.0 - saturate(abs(ForwardDistance.x-CenterControlB._42)/ForwardDistance.y);
		// 
		mv.z += 1.0 - saturate(abs(BackDistance.x-CenterControl._43)/BackDistance.y);
		// 
		mv.y += 1.0 - saturate(abs(UpDistance.x-RightArm._42)/UpDistance.y);
		mv.y += 1.0 - saturate(abs(UpDistance.x-LeftArm._42)/UpDistance.y);
		// 
		mv.y -= 1.0 - saturate(abs(DownDistance.x-RightArm._42)/DownDistance.y);
		mv.y -= 1.0 - saturate(abs(DownDistance.x-LeftArm._42)/DownDistance.y);
		// ]ɈړAtsɒ
		float4x4 rot = Quaternion2Matrix(QuaternionInverse(tex2D(smpMoveMat1, float2(0.5,0.75))));
		//mv.z-=0.1;
		Color.rgb -= mul(mv*Velocity, rot);
	}
	else{
		float3 mv=(float3)0;
		// ]
		// E
		mv.x += 1.0 - saturate(abs(RightDistance.x-RightControl._41)/RightDistance.y);
		// 
		mv.x -= 1.0 - saturate(abs(LeftDistance.x-LeftControl._41)/LeftDistance.y);
		// ]
		mv*=RotateYPR;
		// ]NH[^jIvZ
		float4 qY = QuaternionYaw(mv.x);
		float4 qP = QuaternionPitch(mv.y);
		float4 qR = QuaternionRoll(mv.z);
		Color = QuaternionMultiply(QuaternionMultiply(QuaternionMultiply(Color,qY), qP), qR);
	}
	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// eNjbN
technique Main <
	string Script =
		"RenderColorTarget0=texMoveMat1; RenderDepthStencilTarget=texMoveMatDB;"
			"Pass=PassMove1;"
		"RenderColorTarget0=texMoveMat2;"
			"Pass=PassMove2;"
	;
> {
	pass PassMove1 < string Script= "Draw=Buffer;"; > {
		ALPHABLENDENABLE = FALSE;
	    ALPHATESTENABLE=FALSE;
		AlphaBlendEnable = FALSE;
		ZENABLE = FALSE;
		ZWRITEENABLE = FALSE;
		VertexShader = compile vs_3_0 MoveVS();
		PixelShader = compile ps_3_0 MovePS1();
	}
	pass PassMove2 < string Script= "Draw=Buffer;"; > {
		ALPHABLENDENABLE = FALSE;
	    ALPHATESTENABLE=FALSE;
		AlphaBlendEnable = FALSE;
		ZENABLE = FALSE;
		ZWRITEENABLE = FALSE;
		VertexShader = compile vs_3_0 MoveVS();
		PixelShader = compile ps_3_0 MovePS2();
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////